#include "TKheaders.h"
#include "TK_3GSMAPH.h"

int main(int argc, char *argv[]){


    /* declare Data struct */
    TKINFO granuleHandle3GSMAPH;

    L3GSMAPH_GRID  L3GSMAPH;

    /* declare character */
    char job[256];
    char inputfile[256];

    strcpy(job, argv[1]);
    strcpy(inputfile, argv[2]);

    /* declare variables */
    int nlon, nlat;
    int status;
 
    /* declare array */
    float  hourlyPrecipRateGC[3600][1800];

    /* HDF file open */
    status = TKopen(inputfile, "3GSMAPH", TKREAD, "HDF5", job, &granuleHandle3GSMAPH, 1);
    if(status != TK_SUCCESS) {
        fprintf(stderr, "error:file open error[%s] input3GSMAPH\n", inputfile);
    }

    /* Grid data read */
    status = TKreadGrid( &granuleHandle3GSMAPH, &L3GSMAPH);

    /* surfacePrecipitation data read */
    for (nlon=0; nlon<3600; nlon++){
	for (nlat=0; nlat<1800; nlat++){
	       hourlyPrecipRateGC[nlon][nlat] = L3GSMAPH.hourlyPrecipRateGC[nlon][nlat];
	       if( nlon==2630 && nlat==930 ) printf("hourlyPrecipRateGC[%d][%d]= %f (mm/hr)\n",
                                              nlon, nlat, hourlyPrecipRateGC[nlon][nlat]);	
	}
    }

    /* HDF File close*/
    status = TKclose(&granuleHandle3GSMAPH);

    return 0;
}

