#include "TKheaders.h"
#include "TK_2BCMB.h"

int main(int argc, char *argv[]){

    /* declare Data struct */
    TKINFO granuleHandle2BCMB;
    L2BCMB_SWATHS  L2BCMB;

    /* declare character */
    char job[256];
    char inputfile[256];

    strcpy(job, argv[1]);
    strcpy(inputfile, argv[2]);

    /* declare variables */
    int year, month, date, dayOfMon, hour, min;
    int i, j, k;
    int numOfScan;   
    int status;
 
    /* declare array */
    float lat[49], lon[49], surfPrecipTotRate[49];

    /* HDF file open */
    status = TKopen(inputfile, "2BCMB", TKREAD, "HDF5", job, &granuleHandle2BCMB, 1);
    if(status != TK_SUCCESS) {
        fprintf(stderr, "error:file open error[%s] input2BCMB\n", inputfile);
    }
    
    /* META data read */
    status = TKgetMetaInt(&granuleHandle2BCMB, "NS_SwathHeader",
                            "NumberScansGranule", &numOfScan);
    if(status != TK_SUCCESS) {
         fprintf(stderr, "error:file read error[%s]\n", inputfile);
    }

    /* Scan data read */
    for (i=0; i<numOfScan; i++){ 
      status = TKreadScan( &granuleHandle2BCMB, &L2BCMB);

      /* Scantime Read */
      year      = L2BCMB.NS.ScanTime.Year;
      month     = L2BCMB.NS.ScanTime.Month;
      dayOfMon  = L2BCMB.NS.ScanTime.DayOfMonth;
      hour      = L2BCMB.NS.ScanTime.Hour;
      min       = L2BCMB.NS.ScanTime.Minute;

      for (j=0; j<49; j++){

	/* Latitude and Longitude Read */
        lat[j]  = L2BCMB.NS.Latitude[j];
        lon[j]  = L2BCMB.NS.Longitude[j];

	/* surfPrecipTotRate Read */
        surfPrecipTotRate[j] = L2BCMB.NS.surfPrecipTotRate[j];

	/* Print the value */
	if(i == 2395 && j == 7){
	  printf("Scan=%d, Angle=%d\n", i, j);
	  printf("lat=%f, lon=%f\n", lat[j], lon[j]);
	  printf("surfPrecipTotRate= %f (mm/hr)\n",surfPrecipTotRate[j]);
	} 
      }
    }

    /* HDF File close */
    status = TKclose(&granuleHandle2BCMB);

    return 0;
}

