#include "TKheaders.h"
#include "TK_3CMB.h"

int main(int argc, char *argv[]){

    /* declare Data struct */
    TKINFO granuleHandle3CMB;
    L3CMB_GRIDS  L3CMB;

    /* declare character */
    char job[256];
    char inputfile[256];

    strcpy(job, argv[1]);
    strcpy(inputfile, argv[2]);

    /* declare variables */
    int st, rt, hgt, ns, lnL, ltL;
    int status;
 
    /* declare array */
    float  precipTotRate[3][3][16][2][72][28];

    /* HDF file open */
    status = TKopen(inputfile, "3CMB", TKREAD, "HDF5", job, &granuleHandle3CMB, 1);
    if(status != TK_SUCCESS) {
        fprintf(stderr, "error:file open error[%s] input3CMB\n", inputfile);
    }

    /* Grid data read */
    status = TKreadGrid( &granuleHandle3CMB, &L3CMB);

    /* precipTotRate data read */
    for (st=0; st<3; st++){
      for (rt=0; rt<3; rt++){
	for (hgt=0; hgt<16; hgt++){
	  for (ns=0; ns<2; ns++){
            for (lnL=0; lnL<72; lnL++){
              for (ltL=0; ltL<28; ltL++){
	        precipTotRate[st][rt][hgt][ns][lnL][ltL] = L3CMB.G1.precipTotRate.mean[st][rt][hgt][ns][lnL][ltL];
		/* Print read value */ 
		if( hgt==7 && ns==1 && lnL==45 && ltL==10 )
		  printf("precipTotRate.mean[%d][%d][%d][%d][%d][%d}= %f (mm/hr)\n",
                          st, rt, hgt, ns, lnL, ltL, precipTotRate[st][rt][hgt][ns][lnL][ltL]);	
	      }
	    }
	  }
	}
      }
    }

    /* HDF File close */
    status = TKclose(&granuleHandle3CMB);

    return 0;
}

