#include "TKheaders.h"
#include "TK_3DPR.h"

#define LTL 28  /* number of low resolution 5$B!k(B grid intervals of latitude from 70$B!k(BS to 70$B!k(BN. */ 
#define LHL 72  /* number of low resolution 5$B!k(B grid intervals of longitude from 180$B!k(BW to 180$B!k(BE. */
#define CHN  5  /* number of channels: KuNS, KaMS, KaHS, DPRMS, KuMS. */
#define RT   3  /* number of rain types: stratiform, convective, all */
#define ST   3  /* number of surface types: ocean, land, all */

int main(int argc, char *argv[]){


    /* declare Data struct */
    TKINFO granuleHandle3DPR;
    L3DPR_GRIDS  L3DPR;

    /* declare character */
    char job[256];
    char inputfile[256];

    strcpy(job, argv[1]);
    strcpy(inputfile, argv[2]);

    /* declare variables */
    int i, j, k, l, m, n;
    int status;
 
    /* declare array */
//    float  precipESurf[ST][RT][CHN][LHL][LTL];
    float  precipESurf[3][3][5][72][28];

    /* HDF file open */
    status = TKopen(inputfile, "3DPR", TKREAD, "HDF5", job, &granuleHandle3DPR, 1);
    if(status != TK_SUCCESS) {
        fprintf(stderr, "error:file open error[%s] input3DPR\n", inputfile);
    }

    /* Grid data read */
    status = TKreadGrid( &granuleHandle3DPR, &L3DPR);

    /* precipRateESurface.mean data read */
    for (j=0; j<ST; j++){
	for (k=0; k<RT; k++){
            for (l=0; l<CHN; l++){
                for (m=0; m<LHL; m++){
                    for (n=0; n<LTL; n++){
	  	       precipESurf[j][k][l][m][n] = L3DPR.G1.precipRateESurface.mean[j][k][l][m][n];
		       if( m==63 && n==14 && l==4 ) 
		         printf("precipRateESurface.mean[%d][%d][%d][%d][%d}= %f (mm/hr)\n",
                                 j, k, l, m, n, precipESurf[j][k][l][m][n]);	
		    }
		}
	    }
	}
    }

    /* HDF File close*/
    status = TKclose(&granuleHandle3DPR);

    return 0;
}

