#include "TKheaders.h"
#include "TK_3PR.h"

int main(int argc, char *argv[]){


    /* declare Data struct */
    TKINFO granuleHandle3PR;
    L3PR_GRIDS  L3PR;

    /* declare character */
    char job[256];
    char inputfile[256];

    strcpy(job, argv[1]);
    strcpy(inputfile, argv[2]);

    /* declare variables */
    int j, k, l, m, n;
    int status;
 
    /* declare array */
    float  precipESurf[3][3][5][72][28];

    /* HDF file open */
    status = TKopen(inputfile, "3PR", TKREAD, "HDF5", job, &granuleHandle3PR, 1);
    if(status != TK_SUCCESS) {
        fprintf(stderr, "error:file open error[%s] input3PR\n", inputfile);
    }

    /* Grid data read */
    status = TKreadGrid( &granuleHandle3PR, &L3PR);

    /* precipRateESurface.mean data read */
    for (j=0; j<3; j++){
	for (k=0; k<3; k++){
            for (l=0; l<5; l++){
                for (m=0; m<72; m++){
                    for (n=0; n<28; n++){
	  	       precipESurf[j][k][l][m][n] = L3PR.G1.precipRateESurface.mean[j][k][l][m][n];
		       if( m==7 && n==15 && l==4 ) 
		         printf("precipRateESurface.mean[%d][%d][%d][%d][%d}= %f (mm/hr)\n",
                                 j, k, l, m, n, precipESurf[j][k][l][m][n]);	
		    }
		}
	    }
	}
    }

    /* HDF File close*/
    status = TKclose(&granuleHandle3PR);

    return 0;
}

